searchNodes=[{"doc":"An HTTP client with a focus on performance, built on top of Mint and NimblePool . We try to achieve this goal by providing efficient connection pooling strategies and avoiding copying wherever possible. Usage In order to use Finch, you must start it and provide a :name . Often in your supervision tree: children = [ { Finch , name : MyFinch } ] Or, in rare cases, dynamically: Finch . start_link ( name : MyFinch ) Once you have started your instance of Finch, you are ready to start making requests: Finch . build ( :get , &quot;https://hex.pm&quot; ) |&gt; Finch . request ( MyFinch ) When using HTTP/1, Finch will parse the passed in URL into a {scheme, host, port} tuple, and maintain one or more connection pools for each {scheme, host, port} you interact with. You can also configure a pool size and count to be used for specific URLs that are known before starting Finch. The passed URLs will be parsed into {scheme, host, port} , and the corresponding pools will be started. See Finch.start_link/1 for configuration options. children = [ { Finch , name : MyConfiguredFinch , pools : %{ :default =&gt; [ size : 10 ] , &quot;https://hex.pm&quot; =&gt; [ size : 32 , count : 8 ] } } ] Pools will be started for each configured {scheme, host, port} when Finch is started. For any unconfigured {scheme, host, port} , the pool will be started the first time it is requested. Note pools are not automatically terminated by default, if you need to terminate them after some idle time, use the pool_max_idle_time option (available only for HTTP1 pools). Telemetry Finch uses Telemetry to provide instrumentation. See the Finch.Telemetry module for details on specific events. Logging TLS Secrets Finch supports logging TLS secrets to a file. These can be later used in a tool such as Wireshark to decrypt HTTPS sessions. To use this feature you must specify the file to which the secrets should be written. If you are using TLSv1.3 you must also add keep_secrets: true to your pool :transport_opts . For example: { Finch , name : MyFinch , pools : %{ default : [ conn_opts : [ transport_opts : [ keep_secrets : true ] ] ] } } There are two different ways to specify this file: The :ssl_key_log_file connection option in your pool configuration. For example: { Finch , name : MyFinch , pools : %{ default : [ conn_opts : [ ssl_key_log_file : &quot;/writable/path/to/the/sslkey.log&quot; ] ] } } Alternatively, you could also set the SSLKEYLOGFILE environment variable.","ref":"Finch.html","title":"Finch","type":"module"},{"doc":"Builds an HTTP request to be sent with request/3 or stream/4 . It is possible to send the request body in a streaming fashion. In order to do so, the body parameter needs to take form of a tuple {:stream, body_stream} , where body_stream is a Stream .","ref":"Finch.html#build/5","title":"Finch.build/5","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Finch.html#child_spec/1","title":"Finch.child_spec/1","type":"function"},{"doc":"Sends an HTTP request and returns a Finch.Response struct. Options :pool_timeout - This timeout is applied when we check out a connection from the pool. Default value is 5_000 . :receive_timeout - The maximum time to wait for a response before returning an error. Default value is 15_000 .","ref":"Finch.html#request/3","title":"Finch.request/3","type":"function"},{"doc":"Start an instance of Finch. Options :name - The name of your Finch instance. This field is required. :pools - A map specifying the configuration for your pools. The keys should be URLs provided as binaries, a tuple {scheme, {:local, unix_socket}} where unix_socket is the path for the socket, or the atom :default to provide a catch-all configuration to be used for any unspecified URLs. See &quot;Pool Configuration Options&quot; below for details on the possible map values. Default value is %{default: [size: 50, count: 1]} . Pool Configuration Options :protocol - The type of connection and pool to use. The default value is :http1 . :size - Number of connections to maintain in each pool. Used only by HTTP1 pools since HTTP2 is able to multiplex requests through a single connection. In other words, for HTTP2, the size is always 1 and the :count should be configured in order to increase capacity. The default value is 50 . :count - Number of pools to start. HTTP1 pools are able to re-use connections in the same pool and establish new ones only when necessary. However, if there is a high pool count and few requests are made, these requests will be scattered across pools, reducing connection reuse. It is recommended to increase the pool count for HTTP1 only if you are experiencing high checkout times. The default value is 1 . :max_idle_time - The maximum number of milliseconds an HTTP1 connection is allowed to be idle before being closed during a checkout attempt. :conn_opts - These options are passed to Mint.HTTP.connect/4 whenever a new connection is established. :mode is not configurable as Finch must control this setting. Typically these options are used to configure proxying, https settings, or connect timeouts. The default value is [] . :pool_max_idle_time - The maximum number of milliseconds that a pool can be idle before being terminated, used only by HTTP1 pools. This options is forwarded to NimblePool and it starts and idle verification cycle that may impact performance if misused. For instance setting a very low timeout may lead to pool restarts. For more information see NimblePool's handle_ping/2 documentation. The default value is :infinity . :conn_max_idle_time - The maximum number of milliseconds an HTTP1 connection is allowed to be idle before being closed during a checkout attempt. The default value is :infinity .","ref":"Finch.html#start_link/1","title":"Finch.start_link/1","type":"function"},{"doc":"Streams an HTTP request and returns the accumulator. A function of arity 2 is expected as argument. The first argument is a tuple, as listed below, and the second argument is the accumulator. The function must return a potentially updated accumulator. Stream commands {:status, status} - the status of the http response {:headers, headers} - the headers of the http response {:data, data} - a streaming section of the http body Options :pool_timeout - This timeout is applied when we check out a connection from the pool. Default value is 5_000 . :receive_timeout - The maximum time to wait for a response before returning an error. Default value is 15_000 .","ref":"Finch.html#stream/5","title":"Finch.stream/5","type":"function"},{"doc":"The :name provided to Finch in start_link/1 .","ref":"Finch.html#t:name/0","title":"Finch.name/0","type":"type"},{"doc":"The stream function given to stream/5 .","ref":"Finch.html#t:stream/1","title":"Finch.stream/1","type":"type"},{"doc":"A request struct.","ref":"Finch.Request.html","title":"Finch.Request","type":"module"},{"doc":"Sets a new private key and value in the request metadata. This storage is meant to be used by libraries and frameworks to inject information about the request that needs to be retrieved later on, for example, from handlers that consume Finch.Telemetry events.","ref":"Finch.Request.html#put_private/3","title":"Finch.Request.put_private/3","type":"function"},{"doc":"Optional request body.","ref":"Finch.Request.html#t:body/0","title":"Finch.Request.body/0","type":"type"},{"doc":"Request headers.","ref":"Finch.Request.html#t:headers/0","title":"Finch.Request.headers/0","type":"type"},{"doc":"An HTTP request method represented as an atom() or a String.t() . The following atom methods are supported: :get , :post , :put , :patch , :delete , :head , :options . You can use any arbitrary method by providing it as a String.t() .","ref":"Finch.Request.html#t:method/0","title":"Finch.Request.method/0","type":"type"},{"doc":"","ref":"Finch.Request.html#t:private_metadata/0","title":"Finch.Request.private_metadata/0","type":"type"},{"doc":"","ref":"Finch.Request.html#t:t/0","title":"Finch.Request.t/0","type":"type"},{"doc":"A Uniform Resource Locator, the address of a resource on the Web.","ref":"Finch.Request.html#t:url/0","title":"Finch.Request.url/0","type":"type"},{"doc":"A response to a request.","ref":"Finch.Response.html","title":"Finch.Response","type":"module"},{"doc":"","ref":"Finch.Response.html#t:t/0","title":"Finch.Response.t/0","type":"type"},{"doc":"Telemetry integration. Unless specified, all times are in :native units. Finch executes the following events: Request Start [:finch, :request, :start] - Executed when Finch.request/3 or Finch.stream/5 is called. Measurements :system_time - The system time. Metadata :name - The name of the Finch instance. :request - The request ( Finch.Request ). Request Stop [:finch, :request, :stop] - Executed after Finch.request/3 or Finch.stream/5 ended. Measurements :duration - Time taken from the request start event. Metadata :name - The name of the Finch instance. :request - The request ( Finch.Request ). :result - The result of the operation. In case of Finch.stream/5 this is {:ok, acc} | {:error, Exception.t()} , where acc is the accumulator result of the reducer passed in Finch.stream/5 . In case of Finch.request/3 this is {:ok, Finch.Response.t()} | {:error, Exception.t()} . Request Exception [:finch, :request, :exception] - Executed when an exception occurs while executing Finch.request/3 or Finch.stream/5 . Measurements :duration - The time it took since the start before raising the exception. Metadata :name - The name of the Finch instance. :request - The request ( Finch.Request ). :kind - The type of exception. :reason - Error description or error data. :stacktrace - The stacktrace. Queue Start [:finch, :queue, :start] - Executed before checking out a connection from the pool. Measurements :system_time - The system time. Metadata :pool - The pool's PID. :request - The request ( Finch.Request ). Queue Stop [:finch, :queue, :stop] - Executed after a connection is retrieved from the pool. Measurements :duration - Time taken to check out a pool connection. :idle_time - Elapsed time since the connection was last checked in or initialized. Metadata :pool - The pool's PID. :request - The request ( Finch.Request ). Queue Exception [:finch, :queue, :exception] - Executed if checking out a connection throws an exception. Measurements :duration - The time it took since queue start event before raising an exception. Metadata :request - The request ( Finch.Request ). :kind - The type of exception. :reason - Error description or error data. :stacktrace - The stacktrace. Connect Start [:finch, :connect, :start] - Executed before opening a new connection. If a connection is being re-used this event will not be executed. Measurements :system_time - The system time. Metadata :scheme - The scheme used in the connection. either http or https . :host - The host address. :port - The port to connect on. Connect Stop [:finch, :connect, :stop] - Executed after a connection is opened. Measurements :duration - Time taken to connect to the host. Metadata :scheme - The scheme used in the connection. either http or https . :host - The host address. :port - The port to connect on. :error - This value is optional. It includes any errors that occurred while opening the connection. Send Start [:finch, :send, :start] - Executed before sending a request. Measurements :system_time - The system time. :idle_time - Elapsed time since the connection was last checked in or initialized. Metadata :request - The request ( Finch.Request ). Send Stop [:finch, :send, :stop] - Executed after a request is finished. Measurements :duration - Time taken to make the request. :idle_time - Elapsed time since the connection was last checked in or initialized. Metadata :request - The request ( Finch.Request ). :error - This value is optional. It includes any errors that occurred while making the request. Receive Start [:finch, :recv, :start] - Executed before receiving the response. Measurements :system_time - The system time. :idle_time - Elapsed time since the connection was last checked in or initialized. Metadata :request - The request ( Finch.Request ). Receive Stop [:finch, :recv, :stop] - Executed after a response has been fully received. Measurements :duration - Duration to receive the response. :idle_time - Elapsed time since the connection was last checked in or initialized. Metadata :request - The request ( Finch.Request ). :status - The response status ( Mint.Types.status() ). :headers - The response headers ( Mint.Types.headers() ). :error - This value is optional. It includes any errors that occurred while receiving the response. Receive Exception [:finch, :recv, :exception] - Executed if an exception is thrown before the response has been fully received. Measurements :duration - The time it took before raising an exception Metadata :request - The request ( Finch.Request ). :kind - The type of exception. :reason - Error description or error data. :stacktrace - The stacktrace. Reused Connection [:finch, :reused_connection] - Executed if an existing connection is reused. There are no measurements provided with this event. Metadata :scheme - The scheme used in the connection. either http or https . :host - The host address. :port - The port to connect on. Conn Max Idle Time Exceeded [:finch, :conn_max_idle_time_exceeded] - Executed if a connection was discarded because the conn_max_idle_time had been reached. Measurements :idle_time - Elapsed time since the connection was last checked in or initialized. Metadata :scheme - The scheme used in the connection. either http or https . :host - The host address. :port - The port to connect on. Pool Max Idle Time Exceeded [:finch, :pool_max_idle_time_exceeded] - Executed if a pool was terminated because the pool_max_idle_time has been reached. There are no measurements provided with this event. Metadata :scheme - The scheme used in the connection. either http or https . :host - The host address. :port - The port to connect on. Max Idle Time Exceeded (Deprecated) [:finch, :max_idle_time_exceeded] - Executed if a connection was discarded because the max_idle_time had been reached. Deprecated: use :conn_max_idle_time_exceeded event instead. Measurements :idle_time - Elapsed time since the connection was last checked in or initialized. Metadata :scheme - The scheme used in the connection. either http or https . :host - The host address. :port - The port to connect on.","ref":"Finch.Telemetry.html","title":"Finch.Telemetry","type":"module"},{"doc":"An HTTP error. This exception struct is used to represent errors of all sorts for the HTTP/2 protocol.","ref":"Finch.Error.html","title":"Finch.Error","type":"exception"},{"doc":"","ref":"Finch.Error.html#t:t/0","title":"Finch.Error.t/0","type":"type"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Enhancements Define Finch.child_spec/1 which will automatically use the Finch :name as the :id , allowing users to start multiple instances under the same Supervisor without any additional configuration #202 Include the changelog in the generated HexDocs #201 Fix typo in Finch.Telemetry docs #198","ref":"changelog.html#v0-13-0-2022-07-26","title":"Changelog - v0.13.0 (2022-07-26)","type":"extras"},{"doc":"Enhancements Add support for private request metadata #180 Hide docs for deprecated Finch.request/6 #195 Add support for Mint.UnsafeProxy connections #184 Bug Fixes In v0.11.0 headers and status codes were added to Telemetry events in a way that made invalid assumptions regarding the shape of the response accumulator, this has been resolved in #196 Breaking Changes Telemetry updates #176 Rename the telemetry event :request to :send and :response to :recv . Introduce a new :request field which contains the full Finch.Request.t() in place of the :scheme , :host , :port , :path , :method fields wherever possible. The new :request field can be found on the :request , :queue , :send , and :recv events. Rename the meta data field :error to :reason for all :exception events to follow the standard introduced in telemetry Introduce a new [:finch, :request, :start | :stop | :exception] telemetry event that emits whenever Finch.request/3 or Finch.stream/5 are called.","ref":"changelog.html#v0-12-0-2022-05-03","title":"Changelog - v0.12.0 (2022-05-03)","type":"extras"},{"doc":"Add :pool_max_idle_time option to enable termination of idle HTTP/1 pools. Add :conn_max_idle_time and deprecate :max_idle_time to make the distinction from :pool_max_idle_time more obvious. Add headers and status code to Telemetry events.","ref":"changelog.html#v0-11-0-2022-03-28","title":"Changelog - v0.11.0 (2022-03-28)","type":"extras"},{"doc":"Complete the typespec for Finch.Request.t() Fix the typespec for Finch.build/5 Update deps","ref":"changelog.html#v0-10-2-2022-01-12","title":"Changelog - v0.10.2 (2022-01-12)","type":"extras"},{"doc":"Fix handling of iodata in HTTP/2 request streams.","ref":"changelog.html#v0-10-1-2021-12-27","title":"Changelog - v0.10.1 (2021-12-27)","type":"extras"},{"doc":"Add ability to stream the request body for HTTP/2 requests. Check and respect window sizes during HTTP/2 requests.","ref":"changelog.html#v0-10-0-2021-12-12","title":"Changelog - v0.10.0 (2021-12-12)","type":"extras"},{"doc":"Upgrade NimbleOptions dep to 0.4.0.","ref":"changelog.html#v0-9-1-2021-10-17","title":"Changelog - v0.9.1 (2021-10-17)","type":"extras"},{"doc":"Add support for unix sockets.","ref":"changelog.html#v0-9-0-2021-10-17","title":"Changelog - v0.9.0 (2021-10-17)","type":"extras"},{"doc":"Return Error struct when HTTP2 connection is closed and a timeout occurs. Do not leak messages/connections when cancelling streaming requests.","ref":"changelog.html#v0-8-3-2021-10-15","title":"Changelog - v0.8.3 (2021-10-15)","type":"extras"},{"doc":"Demonitor http/2 connections when the request is done.","ref":"changelog.html#v0-8-2-2021-09-09","title":"Changelog - v0.8.2 (2021-09-09)","type":"extras"},{"doc":"Update mix.exs to allow compatibility with Telemetry v1.0 Avoid appending &quot;?&quot; to request_path when query string is an empty string","ref":"changelog.html#v0-8-1-2021-07-27","title":"Changelog - v0.8.1 (2021-07-27)","type":"extras"},{"doc":"HTTP2 connections will now always return Exceptions.","ref":"changelog.html#v0-8-0-2021-06-23","title":"Changelog - v0.8.0 (2021-06-23)","type":"extras"},{"doc":"Add support for SSLKEYLOGFILE. Drop HTTPS options for default HTTP pools to avoid :badarg errors.","ref":"changelog.html#v0-7-0-2021-05-10","title":"Changelog - v0.7.0 (2021-05-10)","type":"extras"},{"doc":"Return more verbose errors when finch is configured with bad URLs.","ref":"changelog.html#v0-6-3-2021-02-22","title":"Changelog - v0.6.3 (2021-02-22)","type":"extras"},{"doc":"Fix incorrect type spec for stream/5 Add default transport options for keepalive, timeouts, and nodelay.","ref":"changelog.html#v0-6-2-2021-02-19","title":"Changelog - v0.6.2 (2021-02-19)","type":"extras"},{"doc":"Update Mint to 1.2.1, which properly handles HTTP/1.0 style responses that close the connection at the same time as sending the response. Update NimblePool to 0.2.4 which includes a bugfix that prevents extra connections being opened. Fix the typespec for Finch.stream/5. Fix assertion that was not actually being called in a test case.","ref":"changelog.html#v0-6-1-2021-02-17","title":"Changelog - v0.6.1 (2021-02-17)","type":"extras"},{"doc":"Add ability to stream the request body for HTTP/1.x requests.","ref":"changelog.html#v0-6-0-2020-12-15","title":"Changelog - v0.6.0 (2020-12-15)","type":"extras"},{"doc":"Fix deprecation in nimble_options.","ref":"changelog.html#v0-5-2-2020-11-10","title":"Changelog - v0.5.2 (2020-11-10)","type":"extras"},{"doc":"Fix crash in http2 pools when a message is received in disconnected state.","ref":"changelog.html#v0-5-1-2020-10-27","title":"Changelog - v0.5.1 (2020-10-27)","type":"extras"},{"doc":"Add :max_idle_time option for http1 pools Optimize http2 connection closing. Use new lazy pools in NimblePool Additional idle_time measurements for all http1 connection telemetry","ref":"changelog.html#v0-5-0-2020-10-26","title":"Changelog - v0.5.0 (2020-10-26)","type":"extras"},{"doc":"Update all dependencies. This includes bug fixes for Mint.","ref":"changelog.html#v0-4-0-2020-10-2","title":"Changelog - v0.4.0 (2020-10-2)","type":"extras"},{"doc":"Add metadata to connection start telemetry in http/2 pools","ref":"changelog.html#v0-3-2-2020-09-18","title":"Changelog - v0.3.2 (2020-09-18)","type":"extras"},{"doc":"Add HTTP method to telemetry events BUGFIX - Include query parameters in HTTP/2 requests","ref":"changelog.html#v0-3-1-2020-08-29","title":"Changelog - v0.3.1 (2020-08-29)","type":"extras"},{"doc":"HTTP/2 support Streaming support for both http/1.1 and http/2 pools New api for building and making requests typespec fixes","ref":"changelog.html#v0-3-0-2020-06-24","title":"Changelog - v0.3.0 (2020-06-24)","type":"extras"},{"doc":"Response body now defaults to an empty string instead of nil","ref":"changelog.html#v0-2-0-2020-05-06","title":"Changelog - v0.2.0 (2020-05-06)","type":"extras"},{"doc":"Accepts a URI struct in request/3/4/5/6, Todd Resudek Fix http_method() typespec, Ryan Johnson","ref":"changelog.html#v0-1-1-2020-05-04","title":"Changelog - v0.1.1 (2020-05-04)","type":"extras"},{"doc":"Initial Release","ref":"changelog.html#v0-1-0-2020-04-25","title":"Changelog - v0.1.0 (2020-04-25)","type":"extras"}]